; -----------------------------------------------------------------------------
; #####################################################################Begin###
; -----------------------------------------------------------------------------
; Name:               ac'tivAid
; -----------------------------------------------------------------------------
; Version:            1.3.2 beta1
; Date:               2008-06-09 13:00
; Author:             Wolfgang Reszel
; Copyright:          2008 Heise Zeitschriften Verlag GmbH & Co. KG
; AutoHotkey Version: 1.0.47.06
; Language:           German/Dutch (+ English GUI)
; Testplatform:       WinXP
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; --- Description -------------------------------------------------------------
; -----------------------------------------------------------------------------

; *** Deutsch *****************************************************************

; Prft auf die richtige AutoHotkey-Version, startet dann das eigentliche
; Skript.

; #################################################################EndHeader###

; -----------------------------------------------------------------------------
; === Global Settings =========================================================
; -----------------------------------------------------------------------------

#singleinstance force

; -----------------------------------------------------------------------------
; === Initialisation ======================================================cd==
; -----------------------------------------------------------------------------

ScriptName         = ac'tivAid
ScriptNameClean    = activAid
ScriptVersion      = 1.3.2 beta1
neededAHKversion   = 1.0.47.06
ConfigFile         = settings\%ScriptName%.ini
ConfigFile_QuickChangeDir   = settings\QuickChangeDir.ini
qc_ScriptName      = QuickChangeDir

ScriptTitle        = %ScriptName% v%ScriptVersion%

StringReplace, AHKVersion_DL, neededAHKversion, ., , A
StringReplace, ScriptVersion_DL, ScriptVersion, ., ,
StringReplace, ScriptVersion_DL, ScriptVersion_DL, ., ,
StringReplace, ScriptVersion_DL, ScriptVersion_DL, ., _ ,
StringReplace, ScriptVersion_DL, ScriptVersion_DL, %A_Space%,,A

; -----------------------------------------------------------------------------

SplitPath, A_AhkPath,,A_AutoHotkeyPath

If A_AutoHotkeyPath =
   RegRead, A_AutoHotkeyPath, HKLM, SOFTWARE\AutoHotkey, InstallDir

SplitPath, A_AutoHotkeyPath,,,,, A_AutoHotkeyDrive
SplitPath, A_ScriptDir,,,,, A_ScriptDrive
DriveGet, A_AutoHotkeyDriveType, Type, %A_AutoHotkeyDrive%

If A_IsCompiled = 1
   RegRead, A_RealOSVersion, HKEY_CURRENT_USER, Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers, %A_ScriptFullPath%
Else
   RegRead, A_RealOSVersion, HKEY_CURRENT_USER, Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers, %A_AhkPath%
If (A_RealOSVersion <> "" AND ErrorLevel = 0)
   A_RealOSVersion = WIN_VISTA
Else
   A_RealOSVersion = %A_OSVersion%

A_Args =
Loop, %0%
{
   IfInString, %A_Index%, LastWorkingDir:
   {
      StringReplace, LastWorkingDir, %A_Index%, LastWorkingDir:
      continue
   }
   IfInString, %A_Index%, %A_Space%
      A_Args := A_Args " """ %A_Index% """"
   Else
      A_Args := A_Args " " %A_Index%
}
If LastWorkingDir =
{
   If A_WorkingDir <> %A_ScriptDir%
      LastWorkingDir = %A_WorkingDir%
   Else If (FileExist(A_Appdatacommon "\ac'tivAid\" ConfigFile) AND AHKonUSB <> 1)
      LastWorkingDir = %A_Appdatacommon%\ac'tivAid
   Else
      LastWorkingDir = %A_WorkingDir%
}

A_Args = %A_Args% "LastWorkingDir:%LastWorkingDir%"

If ( InStr(A_AutoHotkeyPath, A_ScriptDir) )
   AHKonUSB = 1

; sprachabhngige Variablen, Systemsprache wird ermittelt
IniRead, Lng, %ConfigFile%, %ScriptNameClean%, Language
If Lng = ERROR
   StringRight, Lng, A_Language, 2 ; Sprache ermitteln, wenn nicht in INI festgelegt

If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
{
   lng_wrongAHK         = AutoHotkey %neededAHKversion% oder hher wird bentigt.`nSoll die neueste Version automatisch heruntergeladen und installiert werden?
   lng_wrongAHKNet      = `n`nBeachten Sie, wenn sich mehrere Anwender Portable ac'tivAid`nim Netzwerk teilen, dass sie auf allen PCs ac'tivAid beenden mssen.
   lng_downloadingAHK   = Die neueste Version von AutoHotkey wird heruntergeladen ...
   lng_wr_UpdateCFG     = Wegen der neuen Mglichkeiten von WebSearch sollte die Konfigurations-Datei mit den Suchmaschinen (URLs.cfg) neu angelegt werden.`nAlle manuell hinzugefgte URLs werden gelscht. Von der alten Konfigurations-Datei wird aber eine Sicherung (URLs.bak) angelegt.
   lng_dontcompile      = Sie haben das Start-Skript von ac'tivAid kompiliert.`nac'tivAid.ahk muss vor der Kompilierung einmal gestartet werden.`nSie knnen auch mit der Erweiterung PackAndGo die Kompilierung automatisieren.
   lng_OK               = OK
   lng_cancel           = Abbrechen
}
else        ; = other languages (english)
{
   lng_wrongAHK         = AutoHotkey %neededAHKversion% or higher will be needed.`nShould it be downloaded and installed automatically?
   lng_wrongAHKNet      = `n`nPlease note that you have to close ac'tivAid on every PC`nif you use portable ac'tivAid as a shared network installation!
   lng_downloadingAHK   = Downloading the newest version of AutoHotkey ...
   lng_wr_UpdateCFG     = Due to new capabilities of WebSearch the config-file (URLs.cfg) should be recreated.`nAll added urls will be deleted. A backup of the old config-file (URLs.bak) will be created.
   lng_dontcompile      = You've compiled the start-script of ac'tivAid.`nPlease run ac'tivAid.ahk once before compiling it.`nYou could also try the extension PackAndGo to automate compiling.
   lng_OK               = OK
   lng_cancel           = Cancel
}
If AHKonUSB <> 1
   lng_wrongAHKNet =

If (A_IsCompiled = 1 AND A_Scriptname <> "ac'tivAid-updater.exe")
{
   Msgbox, 16, %ScriptTitle%, %lng_dontcompile%
   ExitApp
}

SetWorkingDir, %A_ScriptDir%

SplitPath, A_ScriptDir, activAidFolderName,,,, Drive

EnvGet, A_LocalAppData, LOCALAPPDATA
IfExist, %A_LocalAppData%\VirtualStore\Program Files\%activAidFolderName%\_temp.tmp
   FileDelete, %A_LocalAppData%\VirtualStore\Program Files\%activAidFolderName%\_temp.tmp
IfExist, %A_LocalAppData%\VirtualStore\Program Files (x86)\%activAidFolderName%\_temp.tmp
   FileDelete, %A_LocalAppData%\VirtualStore\Program Files (x86)\%activAidFolderName%\_temp.tmp

IfNotExist, %A_Temp%
   FileCreateDir, %A_Temp%

FileAppend, write, %A_ScriptDir%\_temp.tmp
MainDirNotWriteable = %ErrorLevel%

If (FileExist( A_LocalAppData "\VirtualStore\Program Files\" activAidFolderName "\_temp.tmp" ) OR FileExist( A_LocalAppData "\VirtualStore\Program Files (x86)\" activAidFolderName "\_temp.tmp" ))
   MainDirNotWriteable = 2

FileDelete, %A_ScriptDir%\_temp.tmp

FileRemoveDir, %A_LocalAppData%\VirtualStore\Program Files\%activAidFolderName%, 1
FileRemoveDir, %A_LocalAppData%\VirtualStore\Program Files (x86)\%activAidFolderName%, 1

If MainDirNotWriteable > 0
   Goto, sub_RunAsAdmin

IfExist, AHKinstall.exe
   FileDelete, AHKinstall.exe

; Prfen, ob richtige AutoHotkey-Version installiert ist
IfExist, updateAHK.cmd
{
   FileDelete, AutoHotkeyInstall.exe
   FileDelete, AutoHotkey*_Install.exe
   FileDelete, AutoHotkey.zip
   FileDelete, update_autohotkey.exe
   FileDelete, update_autohotkey_v*.exe
}
FileDelete, updateAHK.cmd

;QuickNote-Dateien aktualisieren
Loop, 30
{
   IfExist, extensions\ac'tivAid_QuickNote%A_Index%.ahk
   {
      FileRead, qn_NextQNContent, extensions\ac'tivAid_QuickNote.ahk
      StringReplace, qn_NextQNContent, qn_NextQNContent, QuickNote1, QuickNote%A_Index%, All
      StringReplace, qn_NextQNContent, qn_NextQNContent, qn1, qn%A_Index%, All
      StringReplace, qn_NextQNContent, qn_NextQNContent, QuickNote.txt, QuickNote%A_Index%.txt, All
      FileDelete, extensions\ac'tivAid_QuickNote%A_Index%.ahk
      FileAppend, %qn_NextQNContent%, extensions\ac'tivAid_QuickNote%A_Index%.ahk
   }
}
;QuickNote Ende

If A_AHKversion < %neededAHKversion%
{
   IniRead, Betatester, %ConfigFile%, activAid, Betatester, 0

   If (A_IsAdmin = 0 AND MainDirNotWriteable = 1)
      Goto, sub_RunAsAdmin
   If (FileExist("AutoHotkeyInstall.exe") OR FileExist("update_autohotkey.exe") OR FileExist("AutoHotkey*_Install.exe") OR FileExist("update_autohotkey_v*.exe") )
   {
      msgbox = exist
   }
   Else
   {
      MsgBox, 19, %ScriptTitle%, %lng_wrongAHK%%lng_wrongAHKNet%
      IfMsgBox, yes
         msgbox = yes

      IfMsgBox, cancel
         ExitApp

      IfMsgBox, no
      {
         Run, http://www.autohotkey.com/download/
         ExitApp
      }
   }

   If msgbox <>
   {
      If msgbox = yes
      {
         If AHKonUSB = 1
         {
            If Betatester = 1
               Downloaded := func_Download( "http://activaid.rumborak.de/update_autohotkey.exe", "update_autohotkey.exe", lng_downloadingAHK, "AutoHotkey Update (Archive)", 1600 )
            Else
               Downloaded := func_Download( "http://www.heise.de/ct/activaid/download/update_autohotkey_v" AHKVersion_DL ".exe", "update_autohotkey.exe", lng_downloadingAHK, "AutoHotkey Update (Archive)", 1600 )
         }
         Else
            Downloaded := func_Download( "http://www.autohotkey.net/programs/AutoHotkey" AHKVersion_DL "_Install.exe", "AutoHotkeyInstall.exe", lng_downloadingAHK, "AutoHotkey Update", 1600 )
      }
      If (Downloaded = 0 OR msgbox = "exist" )
      {
         Loop, AutoHotkey*_Install.exe
         {
            FileMove, %A_LoopFilename%, AutoHotkeyInstall.exe, 1
         }
         Loop, update_autohotkey_v*.exe
         {
            FileMove, %A_LoopFilename%, update_autohotkey.exe, 1
         }

         If AHKonUSB = 1
         {
            FileAppend, %A_AutoHotkeyDrive%`n, updateAHK.cmd
            FileAppend, cd "%A_AutoHotkeyPath%"`n, updateAHK.cmd
            FileAppend, "%A_ScriptDir%\update_autohotkey.exe"`n, updateAHK.cmd
            FileAppend, %A_ScriptDrive%`n, updateAHK.cmd
            FileAppend, cd "%A_ScriptDir%"`n, updateAHK.cmd
            FileAppend, "%A_AutoHotkeyPath%\AutoHotkey.exe" "%A_ScriptFullPath%"`n, updateAHK.cmd
         }
         Else
         {
            FileAppend, AutoHotkeyInstall.exe /S`n, updateAHK.cmd
            FileAppend, "%A_AutoHotkeyPath%\AutoHotkey.exe" "%A_ScriptFullPath%"`n, updateAHK.cmd
         }
         Run, updateAHK.cmd,,Hide
         DetectHiddenWindows, On
         Loop
         {
            Process, Exist, AutoHotkey.exe
            If ErrorLevel = 0
               Break
            Process, Close, AutoHotkey.exe
         }
         ExitApp
      }
   }

}

IfNotInString, A_Scriptname, -Checker
   FileMove, %ScriptName%_main.ahk, %ScriptName%.ahk, 1

func_ReplaceExtension( "WindowShrinker", "ExplorerShrinker" )

If A_IsCompiled = 1
{
   FileDelete, update.cmd
   Run, ac'tivAid.exe %A_Args%, %LastWorkingDir%
}
Else
{
   IfNotInString, A_Scriptname, -Checker
      Run, %A_AhkPath% /r "%A_ScriptFullPath%" %A_Args%, %LastWorkingDir%
}

ExitApp
Return

func_Download( URL, File, Splashtext, Title, Size )
{
   Thread,Priority,-1000
   global DownloadProgressSplashtext,DownloadProgressFile,DownloadProgressFileSize,DownloadProgressTotalSize,DownloadProgressAddSize,DownloadProgressTitle
   DownloadProgressTotalSize = %Size%

   Suspend, On
   DownloadProgressAddSize = 0
   DownloadProgressSplashtext = %Splashtext%
   DownloadProgressTitle = %Title%
   DownloadProgressFile = %File%
   If Size > 5
      Progress, T FM10 FS10 WM400 WS400 P0 w400 M2, %File%, %DownloadProgressSplashtext%, AutoHotkey Update
   Else
      SplashImage,, T FS9 W400 M2, %DownloadProgressSplashtext%
   SetTimer, tim_DownloadProgress, 10, 1000
   URLDownloadToFile, %URL%, %File%
   ReturnVal = %ErrorLevel%
   FileRead, test, *m2048 %File%
   If (InStr(test,"<html>") AND InStr(test,"404"))
      ReturnVal++

   SetTimer, tim_DownloadProgress, off
   SplashImage, Off
   Progress, Off
   Return %ReturnVal%
}

tim_DownloadProgress:
   FileGetSize, DownloadProgressFileSize, %DownloadProgressFile%, K
   DownloadProgressFileSize := DownloadProgressAddSize + DownloadProgressFileSize
   If DownloadProgressFileSize = %DownloadProgressFileSizeLast%
      return
   If DownloadProgressTotalSize > 5
   {
      DownloadProgressPercentage := Round(DownloadProgressFileSize / DownloadProgressTotalSize * 100,0)
      Progress, %DownloadProgressPercentage%
   }
   Else
   {
      SplashImage,,b1 FS9 W400, %DownloadProgressSplashtext% (%DownloadProgressFileSize% Kb)
   }
   DownloadProgressFileSizeLast = %DownloadProgressFileSize%
Return

sub_RunAsAdmin:
   Critical
   Suspend, On
   If A_IsCompiled = 1
      Run, %A_ScriptDir%\extensions\RunWithAdminRights.exe %RunWithAdminRightsPara% %A_Args%
   Else
      Run, %A_AhkPath% /f "%A_ScriptDir%\extensions\RunWithAdminRights.ahk" %RunWithAdminRightsPara% %A_Args%
   ExitApp
Return

func_StrTranslate(String,TransFrom,TransTo)
{
   Loop, Parse, TransFrom
   {
      StringMid, TransToChar, TransTo, %A_Index%, 1
      StringReplace, String, String, %A_LoopField%, %TransToChar%, All
   }
   Return %String%
}

func_ReplaceExtension( OldExt, NewExt ) {
   global

   IfNotExist, %A_ScriptDir%\extensions\ac'tivAid_%OldExt%.ahk
      Return

   FileDelete, %A_ScriptDir%\extensions\ac'tivAid_%OldExt%.ahk

   FileRead, ExtMain, settings\extensions_main.ini
   StringReplace, ExtMain, ExtMain, _%OldExt%.ahk, _%NewExt%.ahk, A
   StringReplace, ExtMain, ExtMain, `;%OldExt%, `;%NewExt%, A
   FileDelete, settings\extensions_main.ini
   FileAppend, %ExtMain%, settings\extensions_main.ini

   FileRead, ExtHeader, settings\extensions_header.ini
   StringReplace, ExtHeader, ExtHeader, = %OldExt%, = %NewExt%, A
   FileDelete, settings\extensions_header.ini
   FileAppend, %ExtHeader%, settings\extensions_header.ini

   FileRead, ExtSettings, %ConfigFile%
   StringReplace, ExtSettings, ExtSettings, [%OldExt%], [%NewExt%], A
   StringReplace, ExtSettings, ExtSettings, _%OldExt%, _%NewExt%, A
   StringReplace, ExtSettings, ExtSettings, %OldExt%_, %NewExt%_, A
   FileDelete, %ConfigFile%
   FileAppend, %ExtSettings%, %ConfigFile%
}

