; -----------------------------------------------------------------------------
; #############################################################################
; -----------------------------------------------------------------------------
; Name:               dpiCalc
; -----------------------------------------------------------------------------
; Version:            0.1
; Date:               2006-08-15
; Author:             Wolfgang Reszel
; Copyright:          2006 Heise Zeitschriften Verlag GmbH & Co. KG
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; === Initialisation ==========================================================
; -----------------------------------------------------------------------------

#Notrayicon
#Singleinstance force

ScriptName    = dpiCalc
ScriptVersion = 0.1
Author        = Wolfgang Reszel

StringRight, Lng, A_Language, 2 ; Sprache ermitteln, wenn nicht in INI festgelegt

; Sprachabhngige Variablen
If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
{
   lng_dpiCalc   = DPI-Rechner
   lng_Width     = Breite
   lng_Height    = Hhe
   lng_AnalyzeBT = Bild einlesen ...
   lng_Analyzing = Die Pixelmae werden ermittelt ...
   lng_Scale     = Skalieren
   lng_FileMenu  = Datei
   lng_Quit      = Beenden
}
else        ; = Alternativ-Sprache (wenn nicht Deutsch und keine language.ini vorhanden)
{
   lng_dpiCalc   = DPI-Calculator
   lng_Width     = Width
   lng_Height    = Height
   lng_AnalyzeBT = Analyze image ...
   lng_Analyzing = Analyzing image to set the pixel dimensions ...
   lng_Scale     = Scale
   lng_FileMenu  = File
   lng_Quit      = Quit
}

;pxWidth = 2560
;pxHeight = 1920

Menu, FileMenu, Add, %lng_AnalyzeBT%, AnalyzeImage
Menu, FileMenu, Add
Menu, FileMenu, Add, %lng_Quit%, GuiClose

Menu, ScaleMenu, Add, 10`%, Scale
Menu, ScaleMenu, Add, 50`%, Scale
Menu, ScaleMenu, Add, 71`%, Scale
Menu, ScaleMenu, Add, 75`%, Scale
Menu, ScaleMenu, Add, 150`%, Scale
Menu, ScaleMenu, Add, 200`%, Scale
Menu, ScaleMenu, Add, 400`%, Scale
Menu, ScaleMenu, Add, 500`%, Scale
Menu, ScaleMenu, Add, 1000`%, Scale

Menu, MainMenu, Add, %lng_FileMenu%, :FileMenu
Menu, MainMenu, Add, %lng_Scale%, :ScaleMenu

Gui, Menu, MainMenu
Gui, Add, Text, 0x1000 x0 y0 w232 h2

Gui, Font, S11 CDefault Bold, Verdana
Gui, Add, Text, x16 y13 w220 h30 , %lng_dpiCalc%
Gui, Font, ,
Gui, Add, Edit, Number x16 y67 w60 h20 vpxWidth gcalcpxWidth, %pxWidth%
Gui, Add, Edit, Number x126 y67 w60 h20 vpxHeight gcalcpxHeight, %pxHeight%
Gui, Add, Text, x78 y70 w30 h20 , Pixel
Gui, Add, Text, x188 y70 w30 h20 , Pixel
Gui, Add, Edit, x16 y97 w60 h20 vmmWidth gcalcmmWidth
Gui, Add, Edit, x126 y97 w60 h20 vmmHeight gcalcmmHeight
Gui, Add, Text, x78 y100 w20 h20 , mm
Gui, Add, Text, x188 y100 w20 h20 , mm
Gui, Add, ComboBox, x16 y137 w60 vdpiVal gcalcDpi, 72|144|250|300||304|360|720|2400|2540
Gui, Add, Text, x78 y140 w30 h20 , dpi
Gui, Add, Button, x16 y177 w90 h20 gAnalyzeImage , %lng_AnalyzeBT%
Gui, Add, Button, x126 y177 w90 h20 gGuiClose , %lng_Quit%
Gui, Font, Bold,
Gui, Add, Text, x16 y47 w60 h20 , %lng_Width%
Gui, Add, Text, x126 y47 w60 h20 , %lng_Height%
Gui, Font, ,
Gui, Add, Text, x111 y70 w10 h20 , x
Gui, Add, Text, x111 y100 w10 h20 , x
Gui, Show, h214 w232, %lng_dpiCalc% v%ScriptVersion%

dpiVal = 300

Return

GuiEscape:
GuiClose:
ExitApp

AnalyzeImage:
   Critical
   Gui, +OwnDialogs
   Gui, +Disabled
   FileSelectFile, ImageFile,,,%lng_AnalyzeBT%,*.jpg; *.gif; *.png; *.tif
   IfExist, %ImageFile%
   {
      SplashImage,,b1 cwFFFFc0 FS10, %lng_Analyzing%
      ImageWxH(ImageFile)
      pxHeight = %ImageH%
      pxWidth = %ImageW%
      mmHeight := Round(pxHeight/dpiVal*25.4,2)
      mmWidth := Round(pxWidth/dpiVal*25.4,2)
      SplashImage, Off
      GuiControl,, pxHeight, %pxHeight%
      GuiControl,, pxWidth, %pxWidth%
      GuiControl,, mmHeight, %mmHeight%
      GuiControl,, mmWidth, %mmWidth%
   }
   Gui, -Disabled
Return

getAllVars:
   GuiControlGet, mmHeight
   GuiControlGet, mmWidth
   GuiControlGet, pxHeight
   GuiControlGet, pxWidth
   GuiControlGet, dpiVal
   GuiControlGet, Focus, FocusV
Return

calcmmHeight:
   Gosub, getAllVars
   If Focus <> mmHeight
      Return
   dpiVal := Round(pxHeight/mmHeight*25.4)
   If pxWidth <>
      mmWidth := Round(mmHeight/pxHeight*pxWidth,2)
   GuiControl, Text, dpiVal, %dpiVal%
   GuiControl,, mmWidth, %mmWidth%
Return

calcmmWidth:
   Gosub, getAllVars
   If Focus <> mmWidth
      Return
   dpiVal := Round(pxWidth/mmWidth*25.4)
   If pxHeight <>
      mmHeight := Round(mmWidth/pxWidth*pxHeight,2)
   GuiControl, Text, dpiVal, %dpiVal%
   GuiControl,, mmHeight, %mmHeight%
Return

calcpxHeight:
   Gosub, getAllVars
   If Focus <> pxHeight
      Return
   mmHeight := Round(pxHeight/dpiVal*25.4,2)
   GuiControl,, mmHeight, %mmHeight%
Return

calcpxWidth:
   Gosub, getAllVars
   If Focus <> pxWidth
      Return
   mmWidth := Round(pxWidth/dpiVal*25.4,2)
   GuiControl,, mmWidth, %mmWidth%
Return

calcdpi:
   Gosub, getAllVars
   If Focus <> dpiVal
      Return
   mmWidth := Round(pxWidth/dpiVal*25.4,2)
   mmHeight := Round(pxHeight/dpiVal*25.4,2)
   GuiControl,, mmWidth, %mmWidth%
   GuiControl,, mmHeight, %mmHeight%
Return

ImageWxH(ImageFile) {
   global
   IfNotExist, %ImageFile%
     Return
   Size=2592
   DHW:=A_DetectHiddenWindows
   DetectHiddenWindows, ON
   Gui, 99:-Caption
   Gui, 99:Margin, 0, 0
   Gui, 99:Show,Hide w%Size% h%Size%, ImageWxH.Temporary.GUI
   Gui, 99:Add, Picture, x0 y0 , % ImageFile
   Gui, 99:Show,AutoSize Hide, ImageWxH.Temporary.GUI
   WinGetPos, , ,ImageW,ImageH, ImageWxH.Temporary.GUI
   Gui, 99:Destroy
   DetectHiddenWindows, %DHW%
}

Scale:
   StringTrimRight, Scale, A_Thismenuitem, 1
   mmHeight := Round(mmHeight*Scale/100)
   mmWidth := Round(mmWidth*Scale/100)
   dpiVal := Round(pxWidth/mmWidth*25.4)
   GuiControl, Text, dpiVal, %dpiVal%
   GuiControl,, mmHeight, %mmHeight%
   GuiControl,, mmWidth, %mmWidth%
Return


