; -----------------------------------------------------------------------------
; #############################################################################
; -----------------------------------------------------------------------------
; Name:               ScreenLoupe
; -----------------------------------------------------------------------------
; Prefix:             lup_
; Version:            0.3
; Date:               2007-06-07
; Author:             Wolfgang Reszel
;                     Basiert auf dem Skript ScreenMagnifier von Holomind
; Copyright:          2008 Heise Zeitschriften Verlag GmbH & Co. KG
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; === Initialisation ==========================================================
; -----------------------------------------------------------------------------

init_ScreenLoupe:
   Prefix = lup
   %Prefix%_ScriptName    = ScreenLoupe
   %Prefix%_ScriptVersion = 0.3
   %Prefix%_Author        = Wolfgang Reszel
   RequireExtensions      =
   AddSettings_ScreenLoupe =
   ConfigFile_ScreenLoupe = ; %SettingsDir%\datei.ini

   CustomHotkey_ScreenLoupe =            ; automatisches benutzerdefinierbares Tastaturkrzel? (1 = ja)
   Hotkey_ScreenLoupe       =            ; Standard-Hotkey
   HotkeyPrefix_ScreenLoupe =            ; Prfix, welches vor immer vor dem Tastaturkrzel gesetzt wird

   HideSettings = 0                             ; Wenn 1, dann bekommt die Erweiterung keinen Eintrag im Konfigurationsdialog
   EnableTray_ScreenLoupe   =            ; Soll eine Erweiterung nicht im Tray-Men aufgefhrt werden, muss der Wert 0 betragen

   DisableIfCompiled_ScreenLoupe =       ; Wenn 1, lsst sich die Erweiterung in kompilierter Form nicht de-/aktivieren

   IconFile_On_ScreenLoupe = %A_WinDir%\system32\shell32.dll
   IconPos_On_ScreenLoupe = 23

   CreateGuiID("ScreenLoupe")  ; nchste freie GUI-ID in %GuiID_ScreenLoupe% ablegen und Close/Escape-Label

   ; Sprachabhngige Variablen
   If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
   {
      MenuName                      = %lup_ScriptName% - Bildschirmlupe
      Description                   = Vergrert den Bildschirminhalt am Mauspfeil hnlich einer Lupe. (Basiert auf dem Skript ScreenMagnifier von Holomind)
      lng_lup_ZoomOnOff             = Lupe aktivieren/deaktivieren
      lng_lup_ZoomIn                = Vergrern
      lng_lup_ZoomOut               = Verkleinern
      lng_lup_Width                 = Breite und Hhe der Lupe
      lng_lup_ToolTip               = Ganze Zahlen oder Brche mglich`n(z.B. 1/2 = Hlfte des Bildschirms bzw. Arbeitsbereichs)
      tooltip_lup_Width             = %lng_Lup_ToolTip%
      tooltip_lup_Height            = %lng_Lup_ToolTip%
   }
   else        ; = Alternativ-Sprache (wenn nicht Deutsch und keine language.ini vorhanden)
   {
      MenuName                      = %lup_ScriptName% - screen loupe
      Description                   = Magnify the screen at the mouse cursor position. (Based on the script ScreenMagnifier by Holomind)
      lng_lup_ZoomOnOff             = Activate/deactivate loupe
      lng_lup_ZoomIn                = Zoom in
      lng_lup_ZoomOut               = Zoom out
      lng_lup_Width                 = Width and height of the loupe:
      lng_cr_ToolTip                = Integer or fractions`n(e.g. 1/2 = the half of the screen)
      tooltip_lup_Width             = %lng_Lup_ToolTip%
      tooltip_lup_Height            = %lng_Lup_ToolTip%
   }

   func_HotkeyRead( "lup_ZoomOnOff", ConfigFile , lup_ScriptName, "ZoomOnOffHotkey", "lup_sub_ZoomOnOff", "^+NumpadMult" )
   func_HotkeyRead( "lup_ZoomIn", ConfigFile , lup_ScriptName, "ZoomInHotkey", "lup_sub_ZoomIn", "^+NumpadAdd" )
   func_HotkeyRead( "lup_ZoomOut", ConfigFile , lup_ScriptName, "ZoomOutHotkey", "lup_sub_ZoomOut", "^+NumpadSub" )

   ; Die zustzlichen Unterordner aus der INI-Datei auslesen
   IniRead, lup_Width, %ConfigFile%, %lup_ScriptName%, Width, 1/1
   IniRead, lup_Height, %ConfigFile%, %lup_ScriptName%, Height, 150
   IniRead, lup_Zoom, %ConfigFile%, %lup_ScriptName%, Zoom, 2
Return

SettingsGui_ScreenLoupe:
   ; Schaltflche fr Abfrage eines Tastaturkrzels hinzufgen
   func_HotkeyAddGuiControl( lng_lup_ZoomOnOff, "lup_ZoomOnOff", "xs+10 y+10 w160" )
   func_HotkeyAddGuiControl( lng_lup_ZoomIn, "lup_ZoomIn", "xs+10 y+10 w160" )
   func_HotkeyAddGuiControl( lng_lup_ZoomOut, "lup_ZoomOut", "xs+10 y+10 w160" )

   Gui, Add, Text, xs+10 y+10 w160, %lng_lup_Width%:
   Gui, Add, Edit, x+5 yp-3 w40 gsub_CheckIfSettingsChanged vlup_Width, %lup_Width%
   Gui, Add, Text, x+5 yp+3, x
   Gui, Add, Edit, x+5 yp-3 w40 gsub_CheckIfSettingsChanged vlup_Height, %lup_Height%
Return

; wird aufgerufen, wenn im Konfigurationsdialog OK oder bernehmen angeklickt wird
SaveSettings_ScreenLoupe:
   func_HotkeyWrite( "lup_ZoomOnOff", ConfigFile , lup_ScriptName, "ZoomOnOffHotkey" )
   func_HotkeyWrite( "lup_ZoomIn", ConfigFile , lup_ScriptName, "ZoomInHotkey" )
   func_HotkeyWrite( "lup_ZoomOut", ConfigFile , lup_ScriptName, "ZoomOutHotkey" )

   IniWrite, %lup_Width%, %ConfigFile%, %lup_ScriptName%, Width
   IniWrite, %lup_Height%, %ConfigFile%, %lup_ScriptName%, Height
Return

; Wird aufgerufen, wenn Einstellungen ber das 'Pfeil'-Men hinzugefgt werden, ist nur notwendig wenn AddSettings_ScreenLoupe = 1
AddSettings_ScreenLoupe:
Return

; wird beim Abbrechen des Konfigurationsdialogs aufgerufen
CancelSettings_ScreenLoupe:
Return

; wird beim Aktivieren der Erweiterung aufgerufen
DoEnable_ScreenLoupe:
   func_HotkeyEnable("lup_ZoomIn")
   func_HotkeyEnable("lup_ZoomOut")
   func_HotkeyEnable("lup_ZoomOnOff")
Return

; wird beim Deaktivieren der Erweiterung und auch vor dem Speichern der Einstellungen aufgerufen
DoDisable_ScreenLoupe:
   func_HotkeyDisable("lup_ZoomIn")
   func_HotkeyDisable("lup_ZoomOut")
   func_HotkeyDisable("lup_ZoomOnOff")
   Gosub, ScreenLoupeGuiClose
Return

; wird aufgerufen, wenn der Anwender die Erweiterung auf die Standard-Einstellungen zurcksetzt
DefaultSettings_ScreenLoupe:
Return

; wird aufgerufen, wenn ac'tivAid beendet oder neu geladen wird.
OnExitAndReload_ScreenLoupe:
   Gosub, ScreenLoupeGuiClose
Return

; -----------------------------------------------------------------------------
; === Hotkeys =================================================================
; -----------------------------------------------------------------------------

lup_sub_ZoomOnOff:
   Gui, %GuiID_ScreenLoupe%:+LastFoundExist
   IfWinExist
   {
      Gosub, ScreenLoupeGuiClose
   }
   Else
   {
      CoordMode Mouse, Screen
      lup_Monitor := func_GetMonitorNumber("Mouse")
      MouseGetPos, lup_x, lup_y

      StringReplace, lup_Width, lup_Width, `:, /
      IfInString lup_Width, /
      {
         StringSplit, lup_Width, lup_Width, /
         lup_Rx := Round((Monitor%lup_Monitor%Width*lup_Width1/lup_Width2)/2)
      }
      Else
         lup_Rx := Round(lup_Width/2)

      StringReplace, lup_Height, lup_Height, `:, /
      IfInString lup_Height, /
      {
         StringSplit, lup_Height, lup_Height, /
         lup_Ry := Round((Monitor%lup_Monitor%Height*lup_Height1/lup_Height2)/2)
      }
      Else
         lup_Ry := Round(lup_Height/2)

      lup_Zx := lup_Rx/lup_zoom
      lup_Zy := lup_Ry/lup_zoom

      lup_Nx := lup_x-lup_Rx
      lup_Ny := lup_y-lup_Ry
      If (lup_Nx < Monitor%lup_Monitor%Left)
         lup_Nx := Monitor%lup_Monitor%Left
      If (lup_Nx + lup_Rx*2 > Monitor%lup_Monitor%Right)
         lup_Nx := Monitor%lup_Monitor%Right - lup_Rx*2
      If (lup_Ny < Monitor%lup_Monitor%Top)
         lup_Ny := Monitor%lup_Monitor%Top
      If (lup_Ny + lup_Ry*2 > Monitor%lup_Monitor%Bottom)
         lup_Ny := Monitor%lup_Monitor%Bottom - lup_Ry*2

      WinGet lup_PrintSourceID, ID

      lup_LoupeID := GuiDefault("ScreenLoupe", "+AlwaysOnTop +Disabled +ToolWindow -Border -Caption +E0x00080020")
      Gui,  Show, % "w" 2*lup_Rx " h" 2*lup_Ry " x" lup_Nx " y" lup_Ny, aadScreenLoupe
      WinSet Transparent, 255, ahk_id %lup_LoupeID% ; makes the window invisible to magnification

      hDC := DllCall("GetDC", "Uint", lup_PrintSourceID)
      lup_hdd_frame := DllCall("CreateCompatibleDC", "Uint", hDC)
      lup_hdc_frame := DllCall("CreateCompatibleBitmap", "Uint", hDC, "int", A_ScreenWidth, "int", A_ScreenHeight)
      oBM := DllCall("SelectObject", "Uint", lup_hdd_frame, "Uint", lup_hdc_frame)

      lup_hdd_frame := DllCall("GetDC", UInt, lup_PrintSourceID)
      lup_hdc_frame := DllCall("GetDC", UInt, lup_LoupeID)

      Gosub, lup_tim_Repaint
      DllCall("SelectObject", "Uint", lup_hdd_frame, "Uint", oBM)

      ;DllCall("gdi32.dll\SetStretchBltMode", "uint", lup_hdc_frame, "int", 4 )
      SetTimer, lup_tim_Repaint, 10
   }
Return

lup_sub_ZoomIn:
   Gui, %GuiID_ScreenLoupe%:+LastFoundExist
   IfWinExist
   {
      If (lup_zoom < 31)
         lup_zoom *= 1.1892071150027210667174999705605
      lup_Zx := lup_Rx/lup_zoom
      lup_Zy := lup_Ry/lup_zoom
      IniWrite, %lup_Zoom%, %ConfigFile%, %lup_ScriptName%, Zoom
   }
   Else
      Gosub, lup_sub_ZoomOnOff
Return

lup_sub_ZoomOut:
   Gui, %GuiID_ScreenLoupe%:+LastFoundExist
   IfWinExist
   {
      If (lup_zoom >  1.19)
         lup_zoom /= 1.1892071150027210667174999705605
      Else
      {
         Gosub, lup_sub_ZoomOnOff
         Return
      }
      lup_Zx := lup_Rx/lup_zoom
      lup_Zy := lup_Ry/lup_zoom
      IniWrite, %lup_Zoom%, %ConfigFile%, %lup_ScriptName%, Zoom
   }
   Else
      Gosub, lup_sub_ZoomOnOff
Return

; -----------------------------------------------------------------------------
; === Subroutines =============================================================
; -----------------------------------------------------------------------------

lup_tim_Repaint:
   If (GetKeyState("Shift") AND GetKeyState("Alt"))
   {
      If lup_ResizeKeys =
      {
         Gui,  %GuiID_ScreenLoupe%:-E0x00080020 +Border +Resize -Disabled
         WinSet Transparent, 255, ahk_id %lup_LoupeID% ; makes the window invisible to magnification
      }
      lup_ResizeKeys = 1
      Return
   }
   If lup_ResizeKeys = 1
   {
      Gui,  %GuiID_ScreenLoupe%:+E0x00080020 -Border -Resize +Disabled
      WinSet Transparent, 255, ahk_id %lup_LoupeID% ; makes the window invisible to magnification
      lup_ResizeKeys =
   }
   WinGetPos,,, lup_actWidth, lup_actHeight, ahk_id %lup_LoupeID%

   CoordMode Mouse, Screen
   lup_Monitor := func_GetMonitorNumber("Mouse")
   MouseGetPos, lup_x, lup_y

   StringReplace, lup_Width, lup_Width, `:, /
   IfInString lup_Width, /
   {
      StringSplit, lup_Width, lup_Width, /
      lup_Rx := Round((Monitor%lup_Monitor%Width*lup_Width1/lup_Width2)/2)
   }
   Else
      lup_Rx := Round(lup_Width/2)

   StringReplace, lup_Height, lup_Height, `:, /
   IfInString lup_Height, /
   {
      StringSplit, lup_Height, lup_Height, /
      lup_Ry := Round((Monitor%lup_Monitor%Height*lup_Height1/lup_Height2)/2)
   }
   Else
      lup_Ry := Round(lup_Height/2)

   If (lup_Rx*2 <> lup_actWidth OR lup_Ry*2 <> lup_actHeight)
   {
      lup_Height := lup_actHeight
      lup_Width  := lup_actWidth
      lup_Ry := lup_Height/2
      lup_Rx := lup_Width/2
      IniWrite, %lup_Width%, %ConfigFile%, %lup_ScriptName%, Width
      IniWrite, %lup_Height%, %ConfigFile%, %lup_ScriptName%, Height
   }

   lup_Zx := lup_Rx/lup_zoom
   lup_Zy := lup_Ry/lup_zoom

   lup_Nx := lup_x-lup_Rx
   lup_Ny := lup_y-lup_Ry
   If (lup_Nx < Monitor%lup_Monitor%Left)
      lup_Nx := Monitor%lup_Monitor%Left
   If (lup_Nx + lup_Rx*2 > Monitor%lup_Monitor%Right)
      lup_Nx := Monitor%lup_Monitor%Right - lup_Rx*2
   If (lup_Ny < Monitor%lup_Monitor%Top)
      lup_Ny := Monitor%lup_Monitor%Top
   If (lup_Ny + lup_Ry*2 > Monitor%lup_Monitor%Bottom)
      lup_Ny := Monitor%lup_Monitor%Bottom - lup_Ry*2

   lup_xz := lup_x-lup_Zx + ((lup_Nx+lup_Rx-lup_x)/lup_zoom)
   lup_yz := lup_y-lup_Zy + ((lup_Ny+lup_Ry-lup_y)/lup_zoom)

   If (lup_Nx <> lup_lastNx OR lup_Ny <> lup_lastNy)
      WinMove, ahk_id %lup_LoupeID%,, %lup_Nx%, %lup_Ny%

   lup_lastNx = %lup_Nx%
   lup_lastNy = %lup_Ny%

   DllCall("gdi32.dll\StretchBlt", UInt, lup_hdc_frame, Int,0, Int,0, Int, 2*lup_Rx, Int, 2*lup_Ry, UInt, lup_hdd_frame, UInt, lup_xz, UInt, lup_yz, Int, 2*lup_Zx, Int, 2*lup_Zy, UInt, 0x40000000 | 0x00CC0020) ; SRCCOPY
Return

ScreenLoupeGuiClose:
ScreenLoupeGuiEscape:
   If GuiID_ScreenLoupe =
      Return
   Gui, %GuiID_ScreenLoupe%:+LastFoundExist
   IfWinExist
   {
      SetTimer, lup_tim_Repaint, Off
      DllCall("gdi32.dll\DeleteDC", UInt, lup_hdc_frame )
      DllCall("gdi32.dll\DeleteDC", UInt, lup_hdd_frame )
      Gui, %GuiID_ScreenLoupe%:Destroy
   }
Return

