; -----------------------------------------------------------------------------
; #############################################################################
; -----------------------------------------------------------------------------
; Name:               ThesauroToolTip
; -----------------------------------------------------------------------------
; Prefix:             ttt_
; Version:            0.8
; Date:               2008-05-23
; Author:             Wolfgang Reszel
; Copyright:          2008 Heise Zeitschriften Verlag GmbH & Co. KG
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; === Initialisation ==========================================================
; -----------------------------------------------------------------------------

; Initialisierungsroutine, welche beim Start von ac'tivAid aufgerufen wird.
init_ThesauroToolTip:
   Prefix = ttt
   %Prefix%_ScriptName    = ThesauroToolTip
   %Prefix%_ScriptVersion = 0.8
   %Prefix%_Author        = Wolfgang Reszel
   RequireExtensions      =
   CustomHotkey_ThesauroToolTip = 1           ; automatisches benutzerdefinierbares Tastaturkrzel? (1 = ja)
   Hotkey_ThesauroToolTip       = ^+t         ; Standard-Hotkey
   HotkeyPrefix_ThesauroToolTip = $           ; Prfix, welches vor immer vor dem Tastaturkrzel gesetzt wird
   IconFile_On_ThesauroToolTip  = %A_WinDir%\system32\shell32.dll
   IconPos_On_ThesauroToolTip   = 219

   ; Sprachabhngige Variablen
   If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
   {
      MenuName                      = %ttt_ScriptName% - Synonyme vom markierten Wort
      Description                   = Zeigt mittels des Thesaurus von openthesaurus.de Synonyme fr das markierte Wort als Tooltip an.
      lng_ttt_NothingFound          = Suchbegriff nicht gefunden
      lng_ttt_Error                 = Fehler beim Zugriff auf openthesaurus.de.
      lng_ttt_LeoOnMbutton          = Suche automatisch ausfhren, wenn ein Wort mit der mittleren Maustaste markiert wird. (MouseClip)
      lng_ttt_Searching             = Verbinde mit
      lng_ttt_SearchFor             = Bitte Suchbegriff eingeben
      lng_ttt_UseBasicForm          = Verwende Grundform von
      lng_ttt_BasicForm             = Grundform
      lng_ttt_UseDifferentSpelling  = Verwende andere Schreibweise von
      lng_ttt_DifferentSpelling     = Andere Schreibweise
      lng_ttt_ToolTipTimeout        = Sekunden, nach denen der Tooltip automatisch verschwindet
      lng_ttt_CheckProxy            = Prfen Sie zudem Ihre Proxy-Einstellungen im Internet Explorer.`nThesauroToolTip funktioniert nicht bei Proxies mit manueller Anmeldung.`nEvtl. hilft die Aktivierung von "HTTP 1.1 ber Proxy-Verbindungen verwenden" in den Internetoptionen unter Erweitert.`nUnter Umstnden knnte auch der Server nicht erreichbar sein.
      lng_ttt_Browser               = Browser fr Rechtsklick auf ToolTip
      lng_ttt_BrowserError          = Der Browser kann evtl. nicht gestartet werden, Windows meldet:`n
      lng_ttt_SelectBrowser         = Auswhlen ...
      lng_ttt_FileTypeEXE           = Programme (*.exe)
      lng_ttt_SelectWordAtCursor    = Wenn kein Text markiert ist, wird automatisch versucht, das Wort am Cursor zu markieren
   }
   else        ; = Alternativ-Sprache (wenn nicht Deutsch und keine language.ini vorhanden)
   {
      MenuName                      = %ttt_ScriptName% - synonyms of the selected word
      Description                   = Shows synonyms of the selected word as an tooltip via the thesaurus of openthesaurus.de. This works only for the german language.
      lng_ttt_NothingFound          = search item not found
      lng_ttt_Error                 = Error while accessing openthesaurus.de.
      lng_ttt_LeoOnMbutton          = Search automatically when selecting a word with the middle mouse-button. (MouseClip)
      lng_ttt_Searching             = Connecting to
      lng_ttt_SearchFor             = Please enter search item
      lng_ttt_UseBasicForm          = Using basic form of
      lng_ttt_BasicForm             = Basic form
      lng_ttt_UseDifferentSpelling  = Using different case of
      lng_ttt_DifferentSpelling     = Different case
      lng_ttt_ToolTipTimeout        = Seconds, when the tooltip automatically disappears
      lng_ttt_CheckProxy            = Check also your proxy settings in Internet Explorer,`nThesauroToolTip does not work at proxies with manual authentification.`nAlso the server could be down at the moment.
      lng_ttt_Browser               = Browser for right-click on tooltip
      lng_ttt_BrowserError          = Maybe the browser can't be launched, windows returns:`n
      lng_ttt_SelectBrowser         = Choose...
      lng_ttt_FileTypeEXE           = Programs (*.exe)
      lng_ttt_SelectWordAtCursor    = Try to select the word at the cursor position, if no text is selected
   }

   IniRead, ttt_EnableMButton, %ConfigFile%, ThesauroToolTip, LeoOnMButton, 0
   IniRead, ttt_ToolTipTimeout, %ConfigFile%, ThesauroToolTip, ToolTipTimeout, 10
   IniRead, ttt_Browser, %ConfigFile%, ThesauroToolTip, Browser, %A_Space%

   RegisterAdditionalSetting( "ttt", "SelectWordAtCursor", 0 )

   ttt_WebBrowsers = OpWindow,MozillaUIWindowClass,IEFrame
   ttt_SearchCache = |
Return

SettingsGui_ThesauroToolTip:
   If Enable_MouseClip = 1
      Gui, Add, Checkbox, -Wrap xs+10 y+5 gttt_sub_MouseClip vttt_EnableMButton Checked%ttt_EnableMButton%, %lng_ttt_LeoOnMbutton%
   Gui, Add, Text, xs+10 y+16, %lng_ttt_ToolTipTimeout%:
   Gui, Add, Edit, x+5 yp-3 -Wrap r1 Number w40 gsub_CheckIfSettingsChanged vttt_ToolTipTimeout, %ttt_ToolTipTimeout%
   Gui, Add, UpDown, Range1-99, %ttt_ToolTipTimeout%
   Gui, Add, Text, xs+10 y+20, %lng_ttt_Browser%:
   Gui, Add, Edit, R1 x+5 yp-3 -Wrap w290 gsub_CheckIfSettingsChanged vttt_Browser, %ttt_Browser%
   Gui, Add, Button, x+5 -Wrap w80 h21 gttt_sub_SelectBrowser, %lng_ttt_SelectBrowser%
Return

ttt_sub_SelectBrowser:
   Gui, +OwnDialogs
   ttt_Suspended = %A_IsSuspended%
   If ttt_Suspended = 0
      Suspend, On

   FileSelectFile, ttt_Browser_tmp,, %A_Programfiles%, %lng_ttt_Browser%, %lng_ttt_FileTypeEXE%
   If ErrorLevel = 0
      GuiControl,, ttt_Browser, %ttt_Browser_tmp%

   If ttt_Suspended = 0
      Suspend, Off
Return

ttt_sub_MouseClip:
   Gosub, sub_CheckIfSettingsChanged
   GuiControlGet, ttt_EnableMButton_tmp,,ttt_EnableMButton
   If (ttt_EnableMButton_tmp = 1 AND Enable_LeoToolTip <> "")
      GuiControl,,ttt_EnableMButton,0
Return

SaveSettings_ThesauroToolTip:
   IniWrite, %ttt_EnableMButton%, %ConfigFile%, ThesauroToolTip, LeoOnMButton
   IniWrite, %ttt_ToolTipTimeout%, %ConfigFile%, ThesauroToolTip, ToolTipTimeout
   IniWrite, %ttt_Browser%, %ConfigFile%, ThesauroToolTip, Browser
Return

AddSettings_ThesauroToolTip:
Return

CancelSettings_ThesauroToolTip:
Return

DoEnable_ThesauroToolTip:
   If ttt_EnableMButton
      RegisterHook( "MButton", "ThesauroToolTip" )
   EnableMButton_ThesauroToolTip = %ttt_EnableMButton%
Return

DoDisable_ThesauroToolTip:
   ttt_BreakLoop = 1
   If ttt_EnableMButton
      UnRegisterHook( "MButton", "ThesauroToolTip" )
   EnableMButton_ThesauroToolTip = %ttt_EnableMButton%
Return

DefaultSettings_ThesauroToolTip:
Return

OnExitAndReload_ThesauroToolTip:
Return

; -----------------------------------------------------------------------------
; === Hotkeys =================================================================
; -----------------------------------------------------------------------------

; Unterroutine fr das automatische Tastaturkrzel
sub_Hotkey_ThesauroToolTip:
   WinGetClass, ttt_WinClass, A
   CoordMode, Caret, Screen

   If ttt_WinClass Contains %ttt_WebBrowsers%
   {
      ttt_ttX =
      ttt_ttY =
   }
   Else
   {
      ttt_ttX := A_CaretX+10
      ttt_ttY := A_CaretY+10
   }
   gosub, ttt_sub_Search
   SetTimer, ttt_tim_ToolTipOff, % ttt_ToolTipTimeout * 1000
   ttt_BreakLoop =
   Loop
   {
      Input, ttt_SingleKey, L1 I V T0.5, {AppsKey}{F1}{F2}{F3}{F4}{F5}{F6}{F7}{F8}{F9}{F10}{F11}{F12}{Left}{Right}{Up}{Down}{Home}{End}{PgUp}{PgDn}{Del}{Ins}{BS}{Capslock}{Numlock}{PrintScreen}{Pause}
      If ttt_BreakLoop = 1
         Break
      If ErrorLevel = TimeOut
         Continue
      Break
   }
   Gosub, ttt_tim_ToolTipOff
Return

MButton_ThesauroToolTip:
   If (ttt_EnableMButton = 1 AND Enable_MouseClip = 1)
   {
      mc_NoPaste = yes
      ttt_ttX =
      ttt_ttY =
      gosub, ttt_sub_Search
   }
Return

; -----------------------------------------------------------------------------
; === Subroutines =============================================================
; -----------------------------------------------------------------------------


ttt_sub_Search:
   AutoTrim, On
   Coordmode, ToolTip, Screen

   func_GetSelection()
   ttt_searchOrig := Selection
   If (ttt_SelectWordAtCursor = 1 AND ttt_searchOrig = "")
   {
      Send, ^{Left}^+{Right}
      func_GetSelection()
      ttt_searchOrig :=  Selection
   }

   If ttt_searchOrig =
   {
      InputBox, ttt_searchOrig, %ttt_ScriptName% (%ScriptTitle%), %lng_ttt_SearchFor%:,,,115,,,,,%ttt_LastSearchOrig%
      If ErrorLevel = 1
         Return
   }

   ttt_searchFor := func_URLEncode(Ansi2UTF8(ttt_searchOrig))

   tooltip, , , , 8

   ttt_Temp := InStr(ttt_SearchCache, "|" ttt_searchFor "|")
   If ttt_Temp
   {
      ttt_LastLangStr = %ttt_LangStr%
      ttt_lastSearch  = %ttt_searchFor%
      ttt_FinalResult := ttt_ResultCache[%ttt_Temp%]
   }

   StringCaseSense, On
   If ( ( ttt_searchFor <> ttt_lastSearch AND ttt_searchFor <> "" ) OR (ttt_lastSearch = "" AND ttt_searchFor ="") )
   {
      StringCaseSense, Off
      tooltip, %lng_ttt_Searching% openthesaurus.de ..., %ttt_ttX%, %ttt_ttY%, 8
      sleep,100
      URLDownloadToFile, http://www.openthesaurus.de/overview.php?search=1&word=%ttt_searchFor%, %A_Temp%\tttahk.tmp
      FileRead, ttt_Query, %A_Temp%\tttahk.tmp
      FileDelete, %A_Temp%\tttahk.tmp

      StringGetPos, ttt_found, ttt_Query, <p class="firstcompact">
      StringTrimLeft, ttt_Result, ttt_Query, %ttt_found%

      ttt_AddResult =

      ttt_AddResult := ttt_func_StripHtml(ttt_searchOrig) ttt_AddResult "`n`n"

      StringGetPos, ttt_tmp, ttt_Result, <!-- TIME for wiktionary matches`:
      StringLeft, ttt_Result, ttt_Result, %ttt_tmp%
      ttt_Result := RegExReplace(ttt_Result, "\t+","")
      ttt_Result := RegExReplace(ttt_Result, "[ ]+"," ")
      ttt_Result := RegExReplace(ttt_Result, "s)\s*</li>\s*<li[^>]*>\s*",", ")
      ttt_Result := RegExReplace(ttt_Result, "<ul[^>]*>","####")
      ttt_Result := RegExReplace(ttt_Result, "<p class=""compact"">","##*##")
      ttt_Result := UTF82Ansi(ttt_func_StripHtml(ttt_Result))
      ttt_Result := RegExReplace(ttt_Result, "( *\R *)+","`n")
      ttt_Result := RegExReplace(ttt_Result, "\R+####\R+","####")
      ttt_Result := RegExReplace(ttt_Result, "####","`n    ")
      ttt_Result := RegExReplace(ttt_Result, "##\*##","`n`n")
      ttt_Result := RegExReplace(ttt_Result, "(\R +)+","`n    ")

      ttt_Result := RegExReplace(ttt_Result, "\s*(\[[1-9][0-9]*\]) ","`n    $1 ")
      ttt_Result := RegExReplace(ttt_Result, "Wiktionary:\s*Bedeutungen:","Wiktionary-Bedeutungen:")
      ttt_Result := RegExReplace(ttt_Result, ",\s+Synonyme:","`n`nWiktionary-Synonyme:")


      ttt_Result := RegExReplace(ttt_Result, "Quelle:.*freie Dokumentation\n","")
      ttt_Result := RegExReplace(ttt_Result, ",\s*&gt;&gt; mehr Teilwort-Treffer\n","`n")
      ttt_Result := RegExReplace(ttt_Result, "s)Dieser Eintrag basiert.+hier bearbeitet werden.","")

      If ( func_StrLeft(ttt_Result, 2) = "`n`n" )
         StringTrimLeft, ttt_Result, ttt_Result, 2

      ttt_AddIndent =
      If ttt_found > 0
      {
         ttt_FinalResult =
         Loop, Parse, ttt_Result, `,
         {
            IfInstring, A_LoopField, :
               ttt_Words = 0
            ttt_Words++
            IfInString, A_LoopField, Wiktionary-
               ttt_AddIndent := "      "
            If ttt_Words > 5
            {
               ttt_Words = 0
               ttt_FinalResult := ttt_FinalResult A_LoopField ",`n   " ttt_AddIndent
            }
            Else
               ttt_FinalResult := ttt_FinalResult A_LoopField ", "
         }
         ttt_FinalResult = %ttt_AddResult%%ttt_FinalResult%

         Loop
         {
            StringRight, ttt_tmp, ttt_FinalResult, 1
            If (ttt_tmp = " " OR ttt_tmp = "," OR ttt_tmp = "`n")
               StringTrimRight, ttt_FinalResult, ttt_FinalResult, 1
            Else
               Break
         }
      } Else If ttt_found = -1
         ttt_FinalResult = %lng_ttt_NothingFound%!`n%lng_ttt_Error%

      If ttt_Query =
         ttt_FinalResult = %lng_ttt_NothingFound%!`n%lng_ttt_CheckProxy%

      ttt_FinalResult := RegExReplace(ttt_FinalResult, "\R\R+","`n`n")
   }
   Else
      ttt_searchFor = %ttt_lastSearch%

   StringCaseSense, Off

   ttt_Temp := StrLen(ttt_SearchCache)
   ttt_SearchCache = %ttt_SearchCache%%ttt_searchFor%|
   ttt_ResultCache[%ttt_Temp%] = %ttt_FinalResult%

   ttt_lastSearch = %ttt_searchFor%
   ttt_lastSearchOrig = %ttt_searchOrig%
   MouseGetPos, ttt_startX, ttt_startY
   tooltip, %ttt_FinalResult%, %ttt_ttX%, %ttt_ttY%, 8
   SetTimer, ttt_tim_WatchToolTip, 20
Return

ttt_tim_ToolTipOff:
   RButton_tip =
   ttt_BreakLoop = 1
   SetTimer, ttt_tim_ToolTipOff, Off
   tooltip,,,, 8
   SetTimer, ttt_tim_WatchToolTip, Off
Return

ttt_tim_WatchToolTip:
   MouseGetPos, ttt_X, ttt_Y, ttt_WinID
   If ttt_startX <>
   {
      If (ttt_X > ttt_StartX+4 OR ttt_Y > ttt_StartY+4 OR ttt_X < ttt_StartX-4 OR ttt_Y < ttt_StartY-4)
      {
         ttt_startX =
         SetTimer, ttt_tim_ToolTipOff, 2000
      }
   }
   WinGetTitle, ttt_TipText, ahk_id %ttt_WinID%
   If ttt_TipText = %ttt_FinalResult%
   {
      GetKeyState, ttt_LButton, LButton
      GetKeyState, ttt_RButton, RButton
      If ttt_LButton = D
         Gosub, ttt_tim_ToolTipOff
      Else If (ttt_RButton = "D" OR OR RButton_tip = "yes")
      {
         If ttt_Browser =
            Run, http://www.openthesaurus.de/overview.php?search=1&word=%ttt_searchFor%, UseErrorLevel
         Else
            Run, % func_Deref(ttt_Browser) " http://www.openthesaurus.de/overview.php?search=1&word=" ttt_searchFor ,, UseErrorLevel
         If ErrorLevel = ERROR
            func_GetErrorMessage( A_LastError, ttt_ScriptName, lng_ttt_BrowserError  )
         Gosub, ttt_tim_ToolTipOff
      }
      Else
         SetTimer, ttt_tim_ToolTipOff, 1000
   }
   GetKeyState, ttt_ESC, ESC
   If ttt_ESC = D
      SetTimer, ttt_tim_ToolTipOff, 1
Return

ttt_func_StripHtml( ttt_string ) {
   Loop
   {
      StringGetPos, ttt_begin, ttt_string, <
      StringGetPos, ttt_end, ttt_string, >,, %ttt_begin%
      If (ttt_begin = -1 OR ttt_end = -1)
         Break
      StringLeft, ttt_new1, ttt_string, %ttt_begin%
      StringTrimLeft, ttt_new2, ttt_string, % ttt_end+1
      ttt_string = %ttt_new1%%ttt_new2%
   }
   StringReplace, ttt_string, ttt_string, &auml`;, , A
   StringReplace, ttt_string, ttt_string, &uuml`;, , A
   StringReplace, ttt_string, ttt_string, &ouml`;, , A
   StringReplace, ttt_string, ttt_string, &Auml`;, , A
   StringReplace, ttt_string, ttt_string, &Ouml`;, , A
   StringReplace, ttt_string, ttt_string, &Uuml`;, , A
   StringReplace, ttt_string, ttt_string, &szlig`;, , A
   StringReplace, ttt_string, ttt_string, &nbsp`;, %A_Space%, A
   Return ttt_string
}
